> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pnbr.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List shape versions

> Read a Shape's version history.

**Operation ID:** `http.shapes.history`

```http theme={null}
GET /v1/orgs/{org}/projects/{project}/shapes/{id}/history
```


## OpenAPI

````yaml openapi.json GET /v1/orgs/{org}/projects/{project}/shapes/{id}/history
openapi: 3.1.0
info:
  title: Penumbra API
  version: v1
  description: >-
    HTTP reference for Files, search, extraction, reviews, Graph, Shapes and
    sharing.
servers:
  - url: https://api.pnbr.io
    description: Penumbra API
security: []
paths:
  /v1/orgs/{org}/projects/{project}/shapes/{id}/history:
    get:
      tags:
        - Shapes
      summary: List shape versions
      description: |-
        Read a Shape's version history.

        Product guidance: [Shape](/concepts/shape).
      operationId: http.shapes.history
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: project
          in: path
          required: true
          schema:
            type: string
        - name: id
          in: path
          required: true
          schema:
            type: string
        - name: limit
          in: query
          required: false
          description: How many versions, 1 to 100. Defaults to 20.
          schema:
            type: string
            pattern: ^[0-9]{1,3}$
      responses:
        2XX:
          description: Success.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/http_shapes_history_response'
      security:
        - bearerAuth: []
components:
  schemas:
    http_shapes_history_response:
      type: object
      properties:
        data:
          type: object
          properties:
            schema:
              type: string
              const: penumbra.shape-history
            version:
              type: number
              const: 1
            shape_id:
              type: string
            versions:
              type: array
              items:
                type: object
                properties:
                  generation:
                    type: integer
                    minimum: -9007199254740991
                    maximum: 9007199254740991
                  revision_id:
                    type: string
                  artifact_digest:
                    type: string
                  published_at:
                    type: string
                  name:
                    anyOf:
                      - type: string
                      - type: 'null'
                  counts:
                    type: object
                    properties:
                      types:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      properties:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      relationships:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                    required:
                      - types
                      - properties
                      - relationships
                    additionalProperties: false
                  publisher:
                    anyOf:
                      - type: object
                        properties:
                          subject_id:
                            type: string
                          via:
                            type: string
                            enum:
                              - person
                              - credential
                        required:
                          - subject_id
                          - via
                        additionalProperties: false
                      - type: 'null'
                  draft_id:
                    anyOf:
                      - type: string
                      - type: 'null'
                  note:
                    anyOf:
                      - type: string
                      - type: 'null'
                required:
                  - generation
                  - revision_id
                  - artifact_digest
                  - published_at
                  - name
                  - counts
                  - publisher
                  - draft_id
                  - note
                additionalProperties: {}
          required:
            - schema
            - version
            - shape_id
            - versions
          additionalProperties: {}
      required:
        - data
      additionalProperties: false
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.